var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.default=void 0;var _toArray2=_interopRequireDefault(require("@babel/runtime/helpers/toArray"));var _toConsumableArray2=_interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));var _classCallCheck2=_interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));var _createClass2=_interopRequireDefault(require("@babel/runtime/helpers/createClass"));var _classPrivateFieldLooseBase2=_interopRequireDefault(require("@babel/runtime/helpers/classPrivateFieldLooseBase"));var _classPrivateFieldLooseKey2=_interopRequireDefault(require("@babel/runtime/helpers/classPrivateFieldLooseKey"));var _liveConfig=_interopRequireDefault(require("../data/live-config"));var _edition=_interopRequireDefault(require("../models/edition"));var _issue=_interopRequireDefault(require("../models/issue"));var _publication=_interopRequireDefault(require("../models/publication"));var _special=_interopRequireDefault(require("../models/special"));var _date=_interopRequireDefault(require("../utils/date"));var _strings=require("../utils/strings");var _getEditionInfoFromName=(0,_classPrivateFieldLooseKey2.default)("_getEditionInfoFromName");var _getIssue=(0,_classPrivateFieldLooseKey2.default)("_getIssue");var _getIssues=(0,_classPrivateFieldLooseKey2.default)("_getIssues");var _getEditions=(0,_classPrivateFieldLooseKey2.default)("_getEditions");var EditionsHelper=function(){function EditionsHelper(){(0,_classCallCheck2.default)(this,EditionsHelper);}(0,_createClass2.default)(EditionsHelper,null,[{key:"getRouteName",value:function getRouteName(text){return text;}},{key:"getClosestIssue",value:function getClosestIssue(){var issues=arguments.length>0&&arguments[0]!==undefined?arguments[0]:[];var closestIssue=arguments.length>1&&arguments[1]!==undefined?arguments[1]:"";return issues.find(function(issue){return issue.getIssue()===closestIssue||issue.getIssue()<closestIssue;})||issues[0];}},{key:"getIssuesFromPublications",value:function getIssuesFromPublications(){var publications=arguments.length>0&&arguments[0]!==undefined?arguments[0]:[];var mainEdition=arguments.length>1?arguments[1]:undefined;var _ref=arguments.length>2?arguments[2]:undefined,_ref$forceShortcut=_ref.forceShortcut,forceShortcut=_ref$forceShortcut===void 0?false:_ref$forceShortcut,_ref$closestIssue=_ref.closestIssue,closestIssue=_ref$closestIssue===void 0?"":_ref$closestIssue;var issues=[];publications.forEach(function(publication){if(publication.getName()!==mainEdition){var issuesToAdd=[];if(publication.isShortcut()||forceShortcut){if(publication instanceof _publication.default){var subEditions=publication.getGroup();if(subEditions&&subEditions.length>0){var _issuesToAdd;(_issuesToAdd=issuesToAdd).push.apply(_issuesToAdd,(0,_toConsumableArray2.default)(EditionsHelper.getIssuesFromPublications(subEditions,mainEdition,{forceShortcut:true,closestIssue:closestIssue})));}else{issuesToAdd.push(EditionsHelper.getClosestIssue(publication.getIssues(),closestIssue));}}else{issuesToAdd.push(EditionsHelper.getClosestIssue(publication.getIssues(),closestIssue));}}else{issuesToAdd=publication.getIssues();}issuesToAdd.forEach(function(issueToAdd){if(!issues.find(function(issue){return issue.getEdition()===issueToAdd.getEdition()&&issue.getIssue()===issueToAdd.getIssue();})){issues.push(issueToAdd);}});}});return issues;}},{key:"parseEditions",value:function parseEditions(){var _ref2=arguments.length>0&&arguments[0]!==undefined?arguments[0]:{},edition=_ref2.edition,pics=_ref2.pics;return(0,_classPrivateFieldLooseBase2.default)(EditionsHelper,_getEditions)[_getEditions](edition,pics);}},{key:"getDownloadedIssues",value:function getDownloadedIssues(editions){var downloadedIssues=[];editions.forEach(function(edition){downloadedIssues.push.apply(downloadedIssues,(0,_toConsumableArray2.default)(edition.getIssues().filter(function(issue){return issue.isDownloaded();})));downloadedIssues.push.apply(downloadedIssues,(0,_toConsumableArray2.default)(EditionsHelper.getDownloadedIssues(edition.getGroup())));});return downloadedIssues;}},{key:"filterEditions",value:function filterEditions(editions,filter){if(typeof filter==="function"){var filtered=[];for(var i=0;i<editions.length;i++){var availableIssues=editions[i].getIssues().filter(function(issue){return filter(issue);});var addEdition=false;if(availableIssues.length){editions[i].setIssues(availableIssues);addEdition=true;}editions[i].setGroup(EditionsHelper.filterEditions(editions[i].getGroup(),filter));if(editions[i].getGroup().length){addEdition=true;}if(addEdition){filtered.push(editions[i]);}}return filtered;}return editions;}},{key:"parseSpecials",value:function parseSpecials(){var specials=arguments.length>0&&arguments[0]!==undefined?arguments[0]:{};var mSpecials=[];Object.keys(specials).forEach(function(name){var mSpecial=new _special.default();mSpecial.setName(name);mSpecial.setLazy(name.match(/.+---[0-9]+/)!==null);mSpecial.setIssues((0,_classPrivateFieldLooseBase2.default)(EditionsHelper,_getIssues)[_getIssues](name,specials));mSpecials.push(mSpecial);});return mSpecials;}},{key:"getShortuctEditions",value:function getShortuctEditions(editions){return editions.filter(function(edition){return edition.isShortcut();});}},{key:"getSecondaryEditions",value:function getSecondaryEditions(editions){return editions.reduce(function(result,edition){if(!edition.isSecondary()){result.push.apply(result,(0,_toConsumableArray2.default)(EditionsHelper.getSecondaryEditions(edition.getGroup())));}else{result.push(edition);}return result;},[]);}},{key:"getPublicationFromIssue",value:function getPublicationFromIssue(){var editions=arguments.length>0&&arguments[0]!==undefined?arguments[0]:[];var issue=arguments.length>1?arguments[1]:undefined;var publication;if(issue){publication=editions.find(function(edition){return edition.getName()===issue.getEdition();});if(!publication){editions.forEach(function(edition){var group=edition.getGroup();if(group&&group.length>0){publication=EditionsHelper.getPublicationFromIssue(group,issue);if(publication){publication.setIsShortcut(edition.isShortcut());}}});}}return publication;}},{key:"getEditionByName",value:function getEditionByName(){var editions=arguments.length>0&&arguments[0]!==undefined?arguments[0]:[];var name=arguments.length>1?arguments[1]:undefined;for(var i=0;i<editions.length&&name;i++){if(editions[i].getName()===name){return editions[i];}var found=EditionsHelper.getEditionByName(editions[i].getGroup(),name);if(found){return found;}}return undefined;}},{key:"getValidIssue",value:function getValidIssue(issues){for(var j=0;j<issues.length;j++){var issue=issues[j];if(issue){return issue;}}return undefined;}},{key:"populateIssueOnEditions",value:function populateIssueOnEditions(){var editions=arguments.length>0&&arguments[0]!==undefined?arguments[0]:[];var pics=arguments.length>1&&arguments[1]!==undefined?arguments[1]:{};for(var i=0;i<editions.length;i++){var issues=(0,_classPrivateFieldLooseBase2.default)(EditionsHelper,_getIssues)[_getIssues](editions[i],pics).reverse();if(issues.length){editions[i].setIssues(issues);editions[i].setLazy(false);}if(editions[i].getGroup().length){EditionsHelper.populateIssueOnEditions(editions[i].getGroup(),pics);}}}},{key:"updateDownloadIssues",value:function updateDownloadIssues(){var editions=arguments.length>0&&arguments[0]!==undefined?arguments[0]:[];var downloadedIssues=arguments.length>1&&arguments[1]!==undefined?arguments[1]:[];if(!downloadedIssues.length||!editions.length){return;}for(var i=0;i<editions.length;i++){EditionsHelper.updateDownloadIssues(editions[i].getGroup(),downloadedIssues);editions[i].getIssues().forEach(function(issue){for(var j=0;j<downloadedIssues.length;j++){if(downloadedIssues[j].edition===issue.getEdition()&&downloadedIssues[j].issue===issue.getIssue()){issue.setDownloaded(true);break;}}});}}},{key:"getFirstValidIssue",value:function getFirstValidIssue(){var editions=arguments.length>0&&arguments[0]!==undefined?arguments[0]:[];var issue;for(var i=0;i<editions.length&&!issue;i++){var edition=editions[i];if(edition){if(edition.getIssues()){issue=EditionsHelper.getValidIssue(edition.getIssues());}if(!issue&&edition.getGroup()){issue=EditionsHelper.getFirstValidIssue(edition.getGroup());}}}return issue;}},{key:"getPreviousLevel",value:function getPreviousLevel(edition,child){var level=arguments.length>2&&arguments[2]!==undefined?arguments[2]:0;if(edition.hasChild(child)){return{parent:level?edition:undefined,items:edition.getGroup()};}var children=edition.getGroup();for(var i=0;i<children.length;i++){var found=this.getPreviousLevel(children[i],child,level+1);if(found){return found;}}return undefined;}},{key:"getIssueLabel",value:function getIssueLabel(issue){var label="";if(issue){label=issue.getDayOfWeekComplete();if(issue.getIssue()===_date.default.getYesterdayString("YYYYMMDD")){label=_liveConfig.default.getLocale().strings("str_yesterday");}}return label;}},{key:"getMainEdition",value:function getMainEdition(edition){try{if(edition){return edition.split(" _ ")[0];}}catch(e){}return"";}},{key:"getAllOtherIssuesForDate",value:function getAllOtherIssuesForDate(editions,issueDate){var editionIssues=[];editions.forEach(function(edition){if(edition.getGroup().length>0){editionIssues.push.apply(editionIssues,(0,_toConsumableArray2.default)(EditionsHelper.getAllOtherIssuesForDate(edition.getGroup(),issueDate)));}else{editionIssues.push.apply(editionIssues,(0,_toConsumableArray2.default)(edition.getIssues().filter(function(issue){return issue.getIssue()===issueDate;})));}});return editionIssues;}},{key:"getAllIssuesForMainEditions",value:function getAllIssuesForMainEditions(editions){var _editions=(0,_toArray2.default)(editions),mainEdition=_editions[0],others=_editions.slice(1);var issues=mainEdition.getIssues();var otherMainEditions=others.filter(function(insert){return insert.isMain();});otherMainEditions.forEach(function(otherMainEdition){var otherIssues=otherMainEdition.getIssues();otherIssues.forEach(function(otherIssue){var found=issues.findIndex(function(issue){return issue.getIssue()===otherIssue.getIssue();})!==-1;if(!found){issues.push(otherIssue);}});});issues.sort(function(issueA,issueB){return issueB.getIssue()-issueA.getIssue();});return issues;}}]);return EditionsHelper;}();function _getEditionInfoFromName2(){var editionName=arguments.length>0&&arguments[0]!==undefined?arguments[0]:"";var splitted=editionName.split("---");return{name:splitted[0],lazy:splitted[1]!==undefined};}function _getIssue2(publication,key,data){var filename=data.filename,closed=data.closed,isPublic=data.public,lastClosed=data.lastClosed,dayOfWeek=data.dayOfWeek,dayOfWeekComplete=data.dayOfWeekComplete,pSetup=data.pSetup,dateLabelAccessibility=data.dateLabelAccessibility,dateLabel=data.dateLabel,pathEdi=data.pathEdi,siteDomain=data.siteDomain,siteDomainCDN=data.siteDomainCDN,machine=data.machine;var info=(0,_classPrivateFieldLooseBase2.default)(EditionsHelper,_getEditionInfoFromName)[_getEditionInfoFromName](publication.getName());var mIssue=new _issue.default();mIssue.setIssue(key);mIssue.setEdition(info.name);mIssue.setFilename(filename);mIssue.setLastClosed(lastClosed);mIssue.setDayOfWeek(dayOfWeek);mIssue.setDayOfWeekComplete((0,_strings.decodeHTML)(dayOfWeekComplete));mIssue.setPSetup(pSetup);mIssue.setDateLabelAccessibility((0,_strings.decodeHTML)(dateLabelAccessibility));mIssue.setDateLabel((0,_strings.decodeHTML)(dateLabel));mIssue.setEditionLabel(publication instanceof _edition.default?publication.getLabel():info.name);mIssue.setPathEdition(pathEdi);mIssue.setSiteDomain(siteDomain);mIssue.setSiteDomainCDN(siteDomainCDN);mIssue.setMachine(machine);mIssue.setPublic(isPublic);mIssue.setClosed(closed);return mIssue;}function _getIssues2(publication){var pics=arguments.length>1&&arguments[1]!==undefined?arguments[1]:{};var mIssues=[];var editionIssues=pics[publication.getName()];if(editionIssues){Object.keys(editionIssues).forEach(function(issue){mIssues.push((0,_classPrivateFieldLooseBase2.default)(EditionsHelper,_getIssue)[_getIssue](publication,issue,editionIssues[issue]));});}return mIssues;}function _getEditions2(){var edition=arguments.length>0&&arguments[0]!==undefined?arguments[0]:{};var pics=arguments.length>1&&arguments[1]!==undefined?arguments[1]:{};var parent=arguments.length>2&&arguments[2]!==undefined?arguments[2]:"";var isParentSecondaryEdition=arguments.length>3&&arguments[3]!==undefined?arguments[3]:false;var mEditions=[];Object.keys(edition).forEach(function(name){var _edition$name=edition[name],_edition$name$label_e=_edition$name.label_edition,label_edition=_edition$name$label_e===void 0?name:_edition$name$label_e,subtitle_edition=_edition$name.subtitle_edition,group=_edition$name.group,_edition$name$force_p=_edition$name.force_position,force_position=_edition$name$force_p===void 0?false:_edition$name$force_p,_edition$name$is_seco=_edition$name.is_secondary_edition,is_secondary_edition=_edition$name$is_seco===void 0?isParentSecondaryEdition:_edition$name$is_seco,_edition$name$is_shor=_edition$name.is_shortcut_edition,is_shortcut_edition=_edition$name$is_shor===void 0?false:_edition$name$is_shor,_edition$name$is_plac=_edition$name.is_placeholder_edition,is_placeholder_edition=_edition$name$is_plac===void 0?false:_edition$name$is_plac,pSetup=_edition$name.pSetup,icon=_edition$name.icon;var info=(0,_classPrivateFieldLooseBase2.default)(EditionsHelper,_getEditionInfoFromName)[_getEditionInfoFromName](name);var mEdition=new _edition.default();mEdition.setName(name);mEdition.setPSetup(pSetup);mEdition.setIsMain(pSetup===_liveConfig.default.getMainPSetupName());mEdition.setLabel((0,_strings.decodeHTML)(label_edition));mEdition.setSubLabel(subtitle_edition);mEdition.setIsSecondary(is_secondary_edition);mEdition.setIsPlaceholder(is_placeholder_edition);mEdition.setIsShortcut(is_shortcut_edition);mEdition.setForcePosition(force_position);mEdition.setGroup((0,_classPrivateFieldLooseBase2.default)(EditionsHelper,_getEditions)[_getEditions](group,pics,name,is_secondary_edition));mEdition.setParent(parent);mEdition.setIcon(icon);mEdition.setLazy(info.lazy);mEdition.setIssues((0,_classPrivateFieldLooseBase2.default)(EditionsHelper,_getIssues)[_getIssues](mEdition,pics).reverse());mEditions.push(mEdition);});return mEditions.sort(function(e1,e2){if(e1.isForcePosition()||e2.isForcePosition()){return 0;}if(e1.getName()<e2.getName()){return-1;}if(e1.getName()>e2.getName()){return 1;}return 0;});}Object.defineProperty(EditionsHelper,_getEditions,{value:_getEditions2});Object.defineProperty(EditionsHelper,_getIssues,{value:_getIssues2});Object.defineProperty(EditionsHelper,_getIssue,{value:_getIssue2});Object.defineProperty(EditionsHelper,_getEditionInfoFromName,{value:_getEditionInfoFromName2});var _default=EditionsHelper;exports.default=_default;
//# sourceMappingURL=editions-helper.js.map